/*
 * Copyright (C) 2013 Deepin, Inc.
 *                    Zhai Xiang <zhaixiang@linuxdeepin.com>
 *
 */

#include <iostream>
#include <string>
#include <unistd.h>

#include "timer.h"

namespace dmt 
{

Timer::Timer(TIMER_CALLBACK func, int interval) 
    :m_func(func), m_tick(0), m_interval(interval), m_is_loop(true) 
{
    if (pthread_create(&m_thread, NULL, &m_thread_callback, this) != 0) 
        std::cout << "pthread_create error" << std::endl;
} 

Timer::~Timer() 
{
    m_is_loop = false;
    pthread_join(m_thread, NULL);
}

void* Timer::m_thread_callback(void* argv) 
{
    Timer* this_ptr = (Timer*) argv;

    while (this_ptr->m_is_loop) 
    {
        if (this_ptr->m_interval < this_ptr->m_tick) 
        {
            this_ptr->m_func();
            this_ptr->m_tick = 0;
        }
        this_ptr->m_tick++;
        usleep(1000);
    }

    return NULL;
}

};
