/*
 * Copyright (C) 2013 Deepin, Inc.
 *                    Zhai Xiang <zhaixiang@linuxdeepin.com>
 *
 */

#ifndef TIMER_H
#define TIMER_H

#include <pthread.h>

namespace dmt 
{

typedef void (*TIMER_CALLBACK)();

class Timer 
{
public:
    Timer(TIMER_CALLBACK func, int interval = 1000);
    ~Timer();

private:
    TIMER_CALLBACK m_func;
    int m_tick;
    int m_interval;
    pthread_t m_thread;
    bool m_is_loop;

private:
    static void* m_thread_callback(void* argv);
};

};

#endif /* TIMER_H */
